// VC6_DialogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VC6_Dialog.h"
#include "VC6_DialogDlg.h"

//----------code added for S2ACOM by chming ----
#include "S2ACOM_i.c"	// this is a server file
#include "S2ACOM.h"		// this is a server file
#include "Comdef.h"		// for usage of BSTR
#include "Atlbase.h"	// for usage of CComBSTR

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVC6_DialogDlg dialog

CVC6_DialogDlg::CVC6_DialogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVC6_DialogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVC6_DialogDlg)
	m_account = _T("");
	m_passwd = _T("");
	m_msisdn = _T("");
	m_message = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVC6_DialogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVC6_DialogDlg)
	DDX_Text(pDX, IDC_EDIT1, m_account);
	DDX_Text(pDX, IDC_EDIT2, m_passwd);
	DDX_Text(pDX, IDC_EDIT3, m_msisdn);
	DDX_Text(pDX, IDC_EDIT4, m_message);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVC6_DialogDlg, CDialog)
	//{{AFX_MSG_MAP(CVC6_DialogDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVC6_DialogDlg message handlers

BOOL CVC6_DialogDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVC6_DialogDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVC6_DialogDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVC6_DialogDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVC6_DialogDlg::OnOK() 
{
	// TODO: Add extra validation here
    CString ServerIP="203.66.172.131";	//Socket to air server ip
	CString ServerPort="8000";			//Socket to air server port
	CString Ret_Buffer=_T("");
	int ret=-99; //init value

    //Get the below two constants from the S2ACOM_i.c
    const IID IID_IS2Air = {0x4F91871D,0x9B96,0x45C2,{0xB6,0x70,0x2D,0x5D,0x9C,0xE5,0xFF,0x44}};

    const CLSID CLSID_S2Air = {0x31C80217,0x22B5,0x4BA9,{0x8A,0x3C,0x0B,0x4F,0xC2,0x4A,0x44,0x1F}};

	UpdateData(TRUE); //Enable DoDataExchange(CDataExchange* pDX)

	//CString to BSTR
    BSTR bServerIP = ServerIP.AllocSysString();
    BSTR bServerPort = ServerPort.AllocSysString();
    BSTR bm_account = m_account.AllocSysString();
    BSTR bm_passwd = m_passwd.AllocSysString();
	BSTR bm_msisdn = m_msisdn.AllocSysString();
	BSTR bm_message = m_message.AllocSysString();
    
	HRESULT hr = CoInitialize(NULL); // Initialize COM library

    CComBSTR mresult;

    if (SUCCEEDED(hr)){ //To check if CoInitialize success or not
       IS2Air *pIS2Air = NULL;
	   hr = CoCreateInstance(CLSID_S2Air, NULL,
		   CLSCTX_INPROC_SERVER, IID_IS2Air, (void**)&pIS2Air);
	   if (SUCCEEDED(hr)){
	       //إ߻PSocket to airsu
		   pIS2Air->StartCon(bServerIP,bServerPort,bm_account,bm_passwd,&ret);
           if(ret==0){ //إ߳su\
	          //}lǰer²TApnǰeh²TAuݦbhIsSendMsg()Yi
	          pIS2Air->SendMsg(bm_msisdn,bm_message,&ret,&mresult);
	          CString Ret_Result=mresult; //BSTR to CString
			  Ret_Buffer.Format("ǰe,ret_code=%d ret_description=",ret);
			  Ret_Buffer+= Ret_Result;
		      AfxMessageBox(Ret_Buffer);
		   }else{
			  Ret_Buffer.Format("إ߳su,ret_code=%d",ret);
			  AfxMessageBox(Ret_Buffer);
		   }
           pIS2Air->EndCon();  //su
           pIS2Air->Release();
	   }else{
           AfxMessageBox("CreateInstance Fail");
	   }
	   CoUninitialize();
	}else{
       AfxMessageBox("Failed to initialize S2ACOM library");
	}

	//release BSTR
    ::SysFreeString(bServerIP);
    ::SysFreeString(bServerPort);
    ::SysFreeString(bm_account);
    ::SysFreeString(bm_passwd);
    ::SysFreeString(bm_msisdn);
    ::SysFreeString(bm_message);	

  //CDialog::OnOK();
}
